# coding: utf-8

"""
    Traveler API

    The API that provides access to Traveler data.  # noqa: E501

    The version of the OpenAPI document: APS-1.6.4
    Contact: djarosz@anl.gov
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from travelerApi.configuration import Configuration


class TravelerKeyValueLabel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'title': 'str',
        'status': 'float',
        'tags': 'list[str]',
        'devices': 'list[str]',
        'user_defined': 'dict(str, ValueLabel)'
    }

    attribute_map = {
        'id': 'id',
        'title': 'title',
        'status': 'status',
        'tags': 'tags',
        'devices': 'devices',
        'user_defined': 'user_defined'
    }

    def __init__(self, id=None, title=None, status=None, tags=None, devices=None, user_defined=None, local_vars_configuration=None):  # noqa: E501
        """TravelerKeyValueLabel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._title = None
        self._status = None
        self._tags = None
        self._devices = None
        self._user_defined = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if title is not None:
            self.title = title
        if status is not None:
            self.status = status
        if tags is not None:
            self.tags = tags
        if devices is not None:
            self.devices = devices
        if user_defined is not None:
            self.user_defined = user_defined

    @property
    def id(self):
        """Gets the id of this TravelerKeyValueLabel.  # noqa: E501


        :return: The id of this TravelerKeyValueLabel.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TravelerKeyValueLabel.


        :param id: The id of this TravelerKeyValueLabel.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def title(self):
        """Gets the title of this TravelerKeyValueLabel.  # noqa: E501


        :return: The title of this TravelerKeyValueLabel.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this TravelerKeyValueLabel.


        :param title: The title of this TravelerKeyValueLabel.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def status(self):
        """Gets the status of this TravelerKeyValueLabel.  # noqa: E501


        :return: The status of this TravelerKeyValueLabel.  # noqa: E501
        :rtype: float
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this TravelerKeyValueLabel.


        :param status: The status of this TravelerKeyValueLabel.  # noqa: E501
        :type: float
        """

        self._status = status

    @property
    def tags(self):
        """Gets the tags of this TravelerKeyValueLabel.  # noqa: E501


        :return: The tags of this TravelerKeyValueLabel.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this TravelerKeyValueLabel.


        :param tags: The tags of this TravelerKeyValueLabel.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def devices(self):
        """Gets the devices of this TravelerKeyValueLabel.  # noqa: E501


        :return: The devices of this TravelerKeyValueLabel.  # noqa: E501
        :rtype: list[str]
        """
        return self._devices

    @devices.setter
    def devices(self, devices):
        """Sets the devices of this TravelerKeyValueLabel.


        :param devices: The devices of this TravelerKeyValueLabel.  # noqa: E501
        :type: list[str]
        """

        self._devices = devices

    @property
    def user_defined(self):
        """Gets the user_defined of this TravelerKeyValueLabel.  # noqa: E501


        :return: The user_defined of this TravelerKeyValueLabel.  # noqa: E501
        :rtype: dict(str, ValueLabel)
        """
        return self._user_defined

    @user_defined.setter
    def user_defined(self, user_defined):
        """Sets the user_defined of this TravelerKeyValueLabel.


        :param user_defined: The user_defined of this TravelerKeyValueLabel.  # noqa: E501
        :type: dict(str, ValueLabel)
        """

        self._user_defined = user_defined

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TravelerKeyValueLabel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TravelerKeyValueLabel):
            return True

        return self.to_dict() != other.to_dict()
